class Player extends Sprite {
  color fillColor;
  float radius;
  float minRadius;
  float maxRadius;
  float dRadius;
  boolean canMove;

  // default constructor
  Player() {
    fillColor = color(255, 255, 0);  // yellow
    minRadius = 10;
    maxRadius = 100;
    radius = (minRadius + maxRadius) / 2.0;
    dRadius = 1;
    canMove = true;
  }

  void render() {
    pushMatrix();
    fill(fillColor);
    stroke(0);
    strokeWeight(3);
    ellipse(x, y, 2 * radius, 2 * radius);
    popMatrix();
  }

  void update() {
    if (canMove) {
      x = mouseX;
      y = mouseY;
      
      radius += dRadius;
      if (radius < minRadius) {
        dRadius = -dRadius;
      }
      if (radius > maxRadius) {
        dRadius = -dRadius;
      }
    }
  }
} // class Player

