/////////////////////////////////////////////////////
//
// Global variables
//
/////////////////////////////////////////////////////

Player player;
Monster motherMonster;
ArrayList<Monster> monsters;
Timer monsterAddTimer;
Timer gameTimer;
int aliveTime;
boolean gameOver;
PFont gameFont;

void setup() {
  size(1000, 1000);
  smooth();
  player = new Player();

  motherMonster = new Monster(500, 500);
  monsters = new ArrayList<Monster>();
  monsters.add(motherMonster);

  monsterAddTimer = new Timer();
  gameTimer = new Timer();

  gameOver = false;
  gameFont = loadFont("Ubuntu-Medium-48.vlw");
}

void draw() {
  background(135, 206, 250); // sky blue

  // player
  player.update();
  player.render();

  // monsters
  for (Monster m : monsters) {
    m.update();
    m.render();

    // check if this monster has hit the user
    if (m.overlaps(player)) {
      m.dx = 0;
      m.dy = 0;
      gameOver = true;
    }
  }

  // add another monster every 5 seconds
  if (!gameOver) {
    if (monsterAddTimer.elapsedMillis() > 5000) {
      Monster m = new Monster(motherMonster.x, motherMonster.y);
      monsters.add(m);
      monsterAddTimer.reset();
      motherMonster = m;
    }
  }

  if (!gameOver) {
    aliveTime = gameTimer.elapsedMillis() / 1000;
  }

  // draw score board
  textFont(gameFont);
  fill(0, 0, 255);
  int score = monsters.size() * aliveTime;
  text("Score: " + score, width - 300, 50);
  
  if (gameOver) {
    player.fillColor = color(255, 0, 0);
    player.canMove = false;
    fill(0, 0, 255);
    textFont(gameFont, 96);
    text("Game Over", 300, 300);
  }
} // draw()

